// Copyright 2007-2009, Kees Cook <kees@outflux.net> License: GPLv3
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdint.h>
#include <string.h>
#include <limits.h> // INT_MAX

int main(int argc, char * argv[])
{
    char * buf;
    int i, x, y;
    int mult;
    void *limit, *start;

    if (argc<4) {
        printf("Need height, width, and 'contents'.  Try:\n");
        printf("  %s 5 15 asdfsadf\n",argv[0]);
        printf("  %s 1294967000 10 asdfsadf\n",argv[0]);
        return 0;
    }

    x=atoi(argv[1]);
    y=atoi(argv[2]);

    if (x >= (INT_MAX / y - 1) ) {
        printf("%d * %d will overflow!\n", x, y);
        // handle error here instead of performing malloc...
    }

    buf = malloc(x*y);  // and this is a size_t to boot, so -1 is very big!
    if (!buf) {
        perror("malloc");
        return 1;
    }

    mult = x*y;
    printf("Allocated memory: %p - %p\n",
           buf,limit=(buf+mult));
    if (mult < x || mult < y) {
        printf("  Oops: %d * %d == %d (wrapped around past zero!)\n",
               x,y,mult);
        printf("    %u < %d !\n",mult, mult < x ? x : y);
    }

    for (i=0; i<y; i++) {
        printf("Copying into %p - %p ... \n",start=buf+(i*x),buf+((i+1)*x)-1);
        if (start > limit) {
            printf("  Uh-oh, %p > %p beyond end of buffer...\n", start, limit);
        }
        snprintf(buf+(i*x),x,"%s",argv[3]);
    }

    return 0;
}
